servo/models/__init__.py
# -*- coding: utf-8 -*-

from .common import *
from .product import *
from .account import *
from .queue import *
from .customer import *
from .device import *
from .note import *
from .order import *
from .invoices import *
from .purchases import *
from .shipments import *
from .parts import *
from .repair import *
from .escalations import *
from .rules import *

servo/models/device.py
# -*- coding: utf-8 -*-

import re
import gsxws
from gsxws import diagnostics
from os.path import basename
from django_countries import countries
from django.core.validators import RegexValidator

from django.db import models
from django.conf import settings
from django.core.files import File
from django.core.cache import cache
from django.dispatch import receiver
from django.utils.text import slugify
from django.urls import reverse
from django.db.models.signals import post_save

from django.contrib.contenttypes.fields import GenericRelation

from django.utils.translation import ugettext_lazy as _
from django.contrib.contenttypes.models import ContentType

from servo import defaults
from servo.validators import sn_validator
from servo.models import GsxAccount, Product, DeviceGroup, TaggedItem


class Device(models.Model):
    """The serviceable device."""

    # @TODO: unique=True would be nice, but complicated...
    sn = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Serial Number"),
        validators=[sn_validator]
    )
    description = models.CharField(
        max_length=128,
        default=_("New Device"),
        verbose_name=_("Description")
    )
    brand = models.CharField(
        blank=True,
        max_length=128,
        default=_("Apple"),
        verbose_name=_("Brand")
    )
    reseller = models.CharField(
        blank=True,
        default='',
        max_length=128,
        verbose_name=_("Reseller")
    )
    created_at = models.DateTimeField(auto_now_add=True, null=True)
    imei = models.CharField(
        blank=True,
        default='',
        max_length=15,
        verbose_name=_("IMEI Number")
    )
    initial_activation_policy = models.CharField(
        default='',
        editable=False,
        max_length=128,
        verbose_name=_("Initial Activation Policy")
    )
    applied_activation_policy = models.CharField(
        default='',
        editable=False,
        max_length=128,
        verbose_name=_("Applied Activation Policy")
    )
    next_tether_policy = models.CharField(
        default='',
        editable=False,
        max_length=128,
        verbose_name=_("Next Tether Policy")
    )
    unlocked = models.BooleanField(default=None, editable=False, null=True)
    slug = models.SlugField(null=True, editable=False, max_length=128)
    PRODUCT_LINES = gsxws.products.models()
    LINE_CHOICES = [(k, x['name']) for k, x in PRODUCT_LINES.items()]
    product_line = models.CharField(
        max_length=16,
        default="OTHER",
        choices=LINE_CHOICES,
        verbose_name=_("Product Line")
    )
    products = models.ManyToManyField(
        Product,
        editable=False,
        help_text=_('Products that are compatible with this device instance')
    )
    config_code = models.CharField(default='', max_length=8, editable=False)
    configuration = models.CharField(
        blank=True,
        default='',
        max_length=256,
        verbose_name=_("Configuration")
    )

    WARRANTY_CHOICES = (
        ('QP', _("Quality Program")),
        ('CS', _("Customer Satisfaction")),
        ('ALW', _("Apple Limited Warranty")),
        ('APP', _("AppleCare Protection Plan")),
        ('CC', _("Custom Bid Contracts")),
        ('CBC', _("Custom Bid Contracts")),  # sometimes CC, sometimes CBC?
        ('WTY', _("3'rd Party Warranty")),
        ('OOW', _("Out Of Warranty (No Coverage)")),
        ('NA', _("Unknown")),
    )

    warranty_status = models.CharField(
        max_length=3,
        default="NA",
        choices=WARRANTY_CHOICES,
        verbose_name=_("Warranty Status")
    )
    username = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Username")
    )
    password = models.CharField(
        blank=True,
        default='',
        max_length=32,
        verbose_name=_("Password")
    )
    purchased_on = models.DateField(
        null=True,
        blank=True,
        verbose_name=_("Date of Purchase")
    )
    purchase_country = models.CharField(
        blank=True,
        max_length=128,
        choices=countries,
        verbose_name=_("Country Of Purchase"),
        default=settings.INSTALL_COUNTRY.upper(),
    )

    sla_description = models.TextField(null=True, editable=False)
    has_onsite = models.BooleanField(
        default=False,
        help_text=_('Device is eligible for onsite repairs in GSX')
    )
    contract_start_date = models.DateField(null=True, editable=False)
    contract_end_date = models.DateField(null=True, editable=False)
    onsite_start_date = models.DateField(null=True, editable=False)
    onsite_end_date = models.DateField(null=True, editable=False)

    parts_and_labor_covered = models.BooleanField(default=False, editable=False)

    tags = GenericRelation(TaggedItem, null=True, blank=True)
    notes = models.TextField(blank=True, default="", verbose_name=_("notes"))

    photo = models.ImageField(
        null=True,
        blank=True,
        upload_to="devices",
        verbose_name=_("Photo")
    )

    image_url = models.URLField(
        null=True,
        blank=True,
        verbose_name=_("Image URL")
    )
    manual_url = models.URLField(
        null=True,
        blank=True,
        verbose_name=_("Manual URL")
    )
    exploded_view_url = models.URLField(
        null=True,
        blank=True,
        verbose_name=_("Exploded View")
    )

    is_vintage = models.BooleanField(
        default=False,
        verbose_name=_('Vintage'),
        help_text=_('Device is considered vintage in GSX')
    )
    fmip_active = models.BooleanField(default=False, editable=False)

    def is_apple_device(self):
        """
        Checks if this is a valid Apple device SN
        """
        valid_sn = gsxws.core.validate(self.sn, 'serialNumber')
        valid_imei = gsxws.core.validate(self.imei, 'alternateDeviceId')
        return valid_sn or valid_imei

    def get_sn(self):
        return self.sn or self.imei

    @property
    def has_warranty(self):
        return self.warranty_status in ('ALW', 'APP', 'CBC',)

    @property
    def tag_choices(self):
        return TaggedItem.objects.filter(content_type__model="device").distinct("tag")

    def add_tags(self, tags: list):
        tags = [x for x in tags if x != ''] # Filter out empty tags

        if not tags:
            return

        content_type = ContentType.objects.get_for_model(Device)
        
        for t in tags:
            tag, created = TaggedItem.objects.get_or_create(content_type=content_type,
                                                            object_id=self.pk,
                                                            tag=t)

        tag.save()
        

    def get_icon(self):
        if re.match('iPad', self.description):
            return "ipad"
        if re.match('iPhone', self.description):
            return "iphone"
        if re.match('iPod shuffle', self.description):
            return "ipod_shuffle"
        if re.match('iPod', self.description):
            return "ipod"
        if re.match('MacBook', self.description):
            return "macbook"

        return "imac"

    def set_wty_status(self, status):
        """
        Translates a GSX warranty status description
        to our internal representation
        """
        if not isinstance(status, basestring):
            return
        if re.match(r"Apple Limited", status):
            self.warranty_status = "ALW"
        if re.match(r"AppleCare", status):
            self.warranty_status = "APP"
        if re.match(r"Customer Satisfaction", status):
            self.warranty_status = "CSC"
        if re.match(r"Custom Bid", status):
            self.warranty_status = "CBC"
        if re.match(r"Out Of", status):
            self.warranty_status = "OOW"

    def to_dict(self):
        result = {'sn': self.sn}
        result['description'] = self.description
        result['warranty_status'] = self.warranty_status
        result['purchased_on'] = self.purchased_on
        result['purchase_country'] = self.purchase_country
        result['username'] = self.username
        result['password'] = self.password
        return result

    @classmethod
    def from_dict(cls, d):
        if d.get('_pk'):
            return cls.objects.get(pk=d['_pk'])

        device = Device()

        for k, v in d:
            if k.startswith('_'):
                continue
            setattr(device, k, v)

        return device

    def to_gsx(self):
        """
        Returns the corresponding gsxws Product object
        """
        if len(self.imei):
            return gsxws.Product(self.imei)
        return gsxws.Product(self.sn)

    @classmethod
    def from_gsx(cls, sn, device=None, cached=True, user=None):
        """
        Initialize new Device with warranty info from GSX
        Or update existing one
        """
        sn = sn.upper()
        cache_key = 'device-%s' % sn

        # Only cache unsaved devices
        if cached and device is None:
            if cache.get(cache_key):
                return cache.get(cache_key)

        arg = gsxws.validate(sn)

        if arg not in ("serialNumber", "alternateDeviceId",):
            raise ValueError(_(u"Invalid input for warranty check: %s") % sn)

        product = gsxws.Product(sn)

        if user and user.location:
            ship_to = user.location.gsx_shipto
        else:
            gsx_act = GsxAccount.get_default_account()
            ship_to = gsx_act.ship_to

        wty = product.warranty(ship_to=ship_to)
        model = product.model()

        if device is None:
            # serialNumber may sometimes come back empty
            serial_number = wty.serialNumber or sn
            device = Device(sn=serial_number)

        from servo.lib.utils import empty

        if empty(device.notes):
            device.notes = wty.notes or ''
            device.notes += wty.csNotes or ''

servo/models/invoices.py
# -*- coding: utf-8 -*-

from django.db import models
from django.conf import settings
from django.utils import timezone
from django.utils.translation import ugettext_lazy as _

from django.dispatch import receiver
from django.db.models.signals import post_save

from servo.models import (User, Customer, Order, Location, 
                          AbstractOrderItem, ServiceOrderItem,)


class Invoice(models.Model):
    created_at = models.DateTimeField(editable=False, auto_now_add=True)
    created_by = models.ForeignKey(settings.AUTH_USER_MODEL,
        null=True,
        editable=False,
        on_delete=models.SET_NULL)

    PAYMENT_METHODS = (
        (0, _("No Charge")),
        (1, _("Cash")),
        (2, _("Invoice")),
        (3, _("Credit Card")),
        (4, _("Mail payment")),
        (5, _("Online payment"))
    )

    payment_method = models.IntegerField(
        editable=False,
        choices=PAYMENT_METHODS,
        default=PAYMENT_METHODS[0][0],
        verbose_name=_("Payment Method")
    )

    is_paid  = models.BooleanField(default=False, verbose_name=_("Paid"))
    paid_at  = models.DateTimeField(null=True, editable=False)
    order    = models.ForeignKey(Order, editable=False, on_delete=models.PROTECT)
    location = models.ForeignKey(
        Location,
        null=True,
        blank=True,
        editable=False,
        on_delete=models.SET_NULL
    )
    customer = models.ForeignKey(
        Customer,
        null=True,
        editable=False,
        on_delete=models.SET_NULL
    )

    # We remember the following so that the customer info on the invoice 
    # doesn't change if the customer is modified or deleted
    customer_name = models.CharField(
        max_length=255,
        default=_("Walk-in"),
        verbose_name=_("Name")
    )
    customer_phone = models.CharField(
        null=True,
        blank=True,
        max_length=128,
        verbose_name=_("Phone")
    )
    customer_email = models.CharField(
        null=True,
        blank=True,
        max_length=128,
        verbose_name=_("Email")
    )
    customer_address = models.CharField(
        null=True,
        blank=True,
        max_length=255,
        verbose_name=_("Address")
    )
    reference = models.CharField(
        null=True,
        blank=True,
        max_length=255,
        verbose_name=_("Reference")
    )

    total_net   = models.DecimalField(max_digits=8, decimal_places=2) # total w/o taxes
    total_tax   = models.DecimalField(max_digits=8, decimal_places=2) # total taxes
    total_gross = models.DecimalField(max_digits=8, decimal_places=2) # total with taxes

    total_margin = models.DecimalField(
        max_digits=8,
        decimal_places=2,
        editable=False
    )

    def get_payment_total(self):
        from django.db.models import Sum
        result = self.payment_set.all().aggregate(Sum('amount'))
        return result['amount__sum']

    def get_payment_methods(self):
        """
        Returns the different payment methods used in this invoice
        """
        payments = self.payment_set.all()
        return [x.get_method_display() for x in payments]

    def dispatch(self, products):
        """
        Dispatches the products in this invoice from the inventory
        """
        for p in products:
            soi = ServiceOrderItem.objects.get(pk=p)
            InvoiceItem.from_soi(soi, self)

            soi.product.sell(soi.amount, self.location)
            soi.dispatched = True
            soi.save()

    def get_absolute_url(self):
        from django.urls import reverse
        return reverse("invoices-view_invoice", args=[self.pk])

    def save(self, *args, **kwargs):
        if self.location is None:
            self.location = self.order.location

        if self.pk is None:
            description = _(u'Order %s dispatched') % self.order.code
            self.order.notify('dispatched', description, self.created_by)

        return super(Invoice, self).save(*args, **kwargs)

    class Meta:
        ordering = ('-id',)
        app_label = 'servo'
        get_latest_by = "id"


class InvoiceItem(AbstractOrderItem):
    """A line item on an invoice."""
    invoice = models.ForeignKey(Invoice, on_delete=models.CASCADE)
    price = models.DecimalField(
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Sales Price")
    )

    @classmethod
    def from_soi(cls, soi, invoice, invoice_item=None):
        """
        Copies SalesOrderItem into an InvoiceItem
        """
        if invoice_item:
            i = invoice_item
        else:
            i = cls(invoice=invoice)

        i.sn = soi.sn
        i.code = soi.code
        i.title = soi.title
        i.price = soi.price
        i.amount = soi.amount
        i.product = soi.product
        i.description = soi.description
        i.created_by = invoice.created_by
        i.save()
        return i

    class Meta:
        app_label = "servo"


class Payment(models.Model):
    invoice = models.ForeignKey(Invoice, on_delete=models.CASCADE)
    METHODS = (
        (0, _("No Charge")),
        (1, _("Cash")),
        (2, _("Invoice")),
        (3, _("Credit Card")),
        (4, _("Mail payment")),
        (5, _("Online payment"))
    )
    method = models.IntegerField(
        choices=METHODS,
        default=METHODS[0][0],
        verbose_name=_("Payment Method")
    )
    created_by = models.ForeignKey(User,
        null=True,
        on_delete=models.SET_NULL)
    created_at = models.DateTimeField(auto_now_add=True)
    amount = models.DecimalField(max_digits=8, decimal_places=2)

    def save(self, *args, **kwargs):
        invoice = self.invoice
        
        if self.method > 0:
            description = _(u'Payment for %0.2f received') % self.amount
            invoice.order.notify('paid', description, self.created_by)

        if invoice.paid_at is None:
            if invoice.get_payment_total() == invoice.total_gross:
                invoice.paid_at = timezone.now()
                invoice.save()

    class Meta:
        app_label = "servo"

servo/forms/__init__.py
# -*- coding: utf-8 -*-

from .base import *
from .orders import *
from .notes import *
from .devices import *
from .product import *
from .repairs import *
from .checkin import *

servo/templates/orders/batch_process.html
{% extends "orders/index.html" %}
{% load bootstrap3 %}
{% load i18n %}

{% block content %}
	<h2>{% trans "Batch Processing" %}</h2>
	<form action="" method="post">
		{% csrf_token %}
		{% bootstrap_form form %}
		{% buttons %}
		<button type="submit" class="btn btn-primary">{% trans "Submit" %}</button>
		{% endbuttons %}
	</form>
{% endblock content %}

servo/templates/orders/checklists.html
{% load servo_tags %}
{% for c in checklists %}
    <h4>{{ c.title }} ({{ order.checklistitemvalue_set.all.count }}/{{ c.checklistitem_set.all.count }})</h4>
  {% for i in c.checklistitem_set.all %}
    <label class="checkbox" style="margin-left:8x">
        <input type="checkbox" data-url="{% url 'orders-toggle_task' order.id i.id %}" class="toggle" {% if order|is_item_complete:i %}checked="checked"{% endif %}/> {{ i.title }} <i class="muted">{{ order|item_completed_by:i }}</i>
    </label>
    {% if forloop.last %}<hr/>{% endif %}
  {% endfor %}
{% endfor %}

servo/templates/orders/devices.html
{% load i18n %}
{% load servo_tags %}

{% for d in order.orderdevice_set.all %}
{% with d.device as device %}
<div class="row-fluid">
  <div class="span3">
    <img src="{{ device.get_photo }}" alt="{{ device.description }}" title="{{ device.description }}"/>
  </div>
  <div class="span9">
    <h3>{{ device.description }}</h3>
  {% if d.is_repeat_service %}
    <span class="label label-important pull-right">{% trans "Repeat Service" %}</span>
  {% endif %}
    <dl class="dl-horizontal">
      <dt>{% trans "Warranty Status" %}</dt>
      <dd>{{ device.get_warranty_status_display }}</dd>
      <dt>{% trans "Purchase Date" %}</dt>
      <dd>{{ device.purchased_on|date:"SHORT_DATE_FORMAT"|default:"-" }}, {{ device.get_purchase_country|default:"-" }}</dd>
      <dt>{% trans "Serial Number" %}</dt>
      <dd>{{ device.sn|default:"-" }}</dd>
    {% if device.configuration %}
      <dt>{% trans "Configration" %}</dt>
      <dd>{{ device.configuration }}</dd>
    {% endif %}
    {% if device.imei %}
      <dt>{% trans "IMEI" %}</dt>
      <dd>{{ device.imei|safe }}</dd>
      <dt>{% trans "Applied Activation Policy" %}</dt>
      <dd>{{ device.applied_activation_policy|default:"-" }}</dd>
      <dt>{% trans "Initial Activation Policy" %}</dt>
      <dd>{{ device.initial_activation_policy|default:"-" }}</dd>
      <dt>{% trans "Next Tether Policy" %}</dt>
      <dd>{{ device.next_tether_policy|default:"-" }}</dd>
      <dt>{% trans "Find My iPhone" %}</dt>
      <dd>{{ device.get_fmip_status|default:"-" }}</dd>
      <dt>{% trans "Unlocked" %}</dt>
      <dd>{{ device.unlocked|yesno }}</dd>
    {% endif %}
    {% if device.username %}
      <dt>{% trans "Username" %}</dt>
      <dd>{{ device.username }}</dd>
    {% endif %}
    {% if device.password %}
      <dt>{% trans "Password" %}</dt>
      <dd>{{ device.password }}</dd>
    {% endif %}
    {% if device.get_coverage_details %}
      <dt>{% trans "Details" %}</dt>
      <dd>{{ device.get_coverage_details|join:"<br/>" }}</dd>
    {% endif %}
    {% if device.notes %}
      <dt>{% trans "Notes" %}</dt>
      <dd>{{ device.notes }}</dd>
    {% endif %}
    {% with device|device_accessories:order as accessories %}
    {% if accessories.count %}
      <dt>{% trans "Accessories" %}</dt>
      <dd>{{ accessories|join:", " }}</dd>
    {% endif %}
    {% endwith %}
    </dl>
    {% if order.queue %}
    <a href="{% url 'orders-list_parts' order.id device.id order.queue_id %}" class="btn btn-small"><i class="icon-wrench"></i> {% trans "Parts" %}</a>
    {% else %}
    <a class="btn btn-small disabled" title="{% trans "Assign order to a queue first" %}"><i class="icon-wrench"></i> {% trans "Parts" %}</a>
    {% endif %}
    {% if order.is_editable %}
      <a href="{% url 'orders-accessories' order.id device.id %}" class="btn btn-small" data-modal="#modal"><i class="icon-hdd"></i> {% trans "Accessories" %}</a>
    {% else %}
      <a class="btn btn-small disabled" href="#"><i class="icon-hdd"></i> {% trans "Accessories" %}</a>
    {% endif %}
    <a href="{% url 'orders-history' order.pk device.pk %}" class="btn btn-small" data-modal="#modal"><i class="icon-time"></i> {% trans "History" %}</a>
    <div class="btn-group">
      <a class="btn btn-small dropdown-toggle" data-toggle="dropdown">
        <i class="icon-cog"></i> {% trans "Diagnostics" %} <span class="caret"></span>
      </a>
      <ul class="dropdown-menu">
      {% if device.is_ios %}
        <li><a href="{% url 'devices-diagnostics' device.pk %}?a=init&amp;order={{ order.pk|safe }}" data-modal="#modal">{% trans "Initiate" %}</a></li>
      {% else %}
        <li class="disabled"><a href="#" data-modal="#modal">{% trans "Initiate" %}</a></li>
      {% endif %}
        <li><a href="{% url 'devices-diagnostics' device.pk %}" data-modal="#modal">{% trans "Fetch" %}</a></li>
        <li><a href="{% url 'diagnostics-fetch_url' %}" target="_blank">{% trans "Open Console" %}</a></li>
        <li><a href="{% url 'devices-select_test' device.pk %}" data-modal="#modal">{% trans "Select Test" %}</a></li>
      </ul>
    </div>
    <div class="btn-group">
      <a class="btn btn-small dropdown-toggle" data-toggle="dropdown" href="#">
        <i class="icon-cog"></i> <span class="caret"></span>
      </a>
      <ul class="dropdown-menu">
      {% if order.can_create_carryin and device.can_create_carryin %}
        <li><a href="{% url 'repairs-create_repair' order.id device.id 'CA' %}">{% trans "Create Carry-In Repair" %}</a></li>
      {% else %}
        <li class="disabled"><a href="#" title="{% trans "Device has open GSX repairs" %}">{% trans "Create Carry-In Repair" %}</a></li>
      {% endif %}
      {% if order.can_create_carryin and device.can_create_carryin and device.has_onsite %}
        <li><a href="{% url 'repairs-create_repair' order.id device.id 'ON' %}">{% trans "Create Onsite Repair" %}</a></li>
      {% else %}
        <li class="disabled"><a href="#">{% trans "Create Onsite Repair" %}</a></li>
      {% endif %}
      {% if order.can_create_carryin and device.can_create_carryin and 0 %}
        <li><a href="{% url 'repairs-create_repair' order.id device.id 'WH' %}">{% trans "Create Mail-In Repair" %}</a></li>
      {% else %}
        <li class="disabled"><a href="#">{% trans "Create Mail-In Repair" %}</a></li>
      {% endif %}
      {% if order.can_create_carryin and device.can_create_carryin and 0 %}
        <li><a href="{% url 'repairs-create_repair' order.id device.id 'RR' %}">{% trans "Create Whole-Unit Exchange" %}</a></li>
      {% else %}
        <li class="disabled"><a href="#">{% trans "Create Whole-Unit Exchange" %}</a></li>
      {% endif %}
        <li class="divider"></li>
        <li><a href="{% url 'repairs-import_repair' order.pk device.pk %}" data-modal="#modal">{% trans "Import GSX Repair" %}</a></li>
        <li class="divider"></li>
        <li><a href="{% url 'devices-update_gsx_details' device.pk %}" class="spin">{% trans "Update Warranty Status" %}</a></li>
        <li class="divider"></li>
        <li><a href="{{ device.get_absolute_url }}">{% trans "Show Device" %}</a></li>
      {% if device.sn == '' %}
        <li class="disabled"><a href="#" target="_blank">{% trans "Show Barcode" %}</a></li>
      {% else %}
        <li><a href="{% url 'barcodes-view' device.sn %}?f=svg" target="_blank">{% trans "Show Barcode" %}</a></li>
      {% endif %}
      </ul>
    </div>
<div class="pull-right">
  <div class="btn-group">
  {% if d.should_report %}
    <a href="{% url 'orders-report_device' order.pk d.pk %}" class="btn btn-success btn-small nofollow active" title="{% trans "Report" %}" data-toggle="button"><i class="icon-ok"></i></a>
  {% else %}
    <a href="{% url 'orders-report_device' order.pk d.pk %}" class="btn btn-success btn-small nofollow" title="{% trans "Report" %}" data-toggle="button"><i class="icon-ok icon-white"></i></a>
  {% endif %}
  </div>
  <div class="btn-group">
  {% if order.is_editable %}
    <a href="{{ device.get_absolute_url }}edit/" class="btn btn-warning btn-small" title="{% trans "Edit" %}"><i class="icon-pencil icon-white"></i></a>
    <a href="{% url 'orders-delete_device' order.id device.id %}" class="btn btn-small btn-danger" data-modal="#modal" title="{% trans "Remove" %}"><i class="icon-trash icon-white"></i></a>
  {% endif %}
  </div>
</div>
</div>
</div>
<hr/>
{% endwith %}
{% empty %}
<div class="row-fluid">
  <div class="span12">
    <div class="empty well"><h3 class="muted">{% trans "Order doesn't contain any devices" %}</h3></div>
  </div>
</div>
{% endfor %}
<p class="clearfix">
  <a href="{% url 'devices-choose' order.pk %}" class="btn pull-right {% if order.is_closed %}disabled{% endif %}" data-modal="#modal"><i class="icon-plus"></i> {% trans "Add Device" %}</a>
</p>
<hr/>

servo/templates/orders/edit_product.html
{% extends "modal.html" %}
{% load i18n %}

{% block body %}

<form method="post" action="{{ request.path }}" class="form-horizontal">
  {% csrf_token %}
  {% include "form_field_snippet.html" with field=form.title %}
  {% include "form_field_snippet.html" with field=form.amount %}
  {% include "form_field_snippet.html" with field=form.price_category %}
  {% include "form_field_snippet.html" with field=form.price %}
  {% if product.is_serialized %}
  {% include "form_field_snippet.html" with field=form.sn %}
  {% include "form_field_snippet.html" with field=form.kbb_sn %}
  {% include "form_field_snippet.html" with field=form.imei %}
  {% endif %}
  {% if product.component_code %}
  {% include "form_field_snippet.html" with field=form.comptia_code %}
  {% include "form_field_snippet.html" with field=form.comptia_modifier %}
  {% endif %}
  {% include "form_field_snippet.html" with field=form.should_report %}
</form>

<script type="text/javascript">
  {% autoescape off %}
  var prices = {{ prices }};
  {% endautoescape %}
  $('#id_price_category').change(function(){
    $('#id_price').val(prices[$(this).val()]);
  });
</script>

{% endblock body %}

servo/templates/orders/parts.html
{% extends "orders/edit.html" %}
{% load servo_tags %}
{% load i18n %}

{% block toolbar %}
{% endblock toolbar %}

{% block first_column %}
<address>
  <strong>{{ device.description }}</strong><br/>
  <small class="muted">{{ device.configuration }}</small><br/>
  <span><a href="{% url 'devices-get_info' device.pk %}" data-modal="#modal">{{ device.get_warranty_status_display }}</a></span> <i class="icon-info-sign"></i><br/>
  <i class="icon-barcode"></i> <a href="#" class="sn">{{ device.sn }}</a>
  <hr/>
  <strong>{% trans "Parts and Services" %}</strong>
  {% include "orders/list_products.html" %}
</address>
<hr/>
<input type="text" class="span12 search-query filter" placeholder="{% trans "Filter results" %}"/>
<a class="btn btn-primary pull-right" style="margin:10px" href="{{ order.get_absolute_url }}">{% trans "Done" %}</a>
{% endblock first_column %}

{% block second_toolbar %}
{% endblock second_toolbar %}

{% block second_column %}

<div class="async" data-url="{{ url }}"><h2 class="text-center muted">{% trans "Fetching parts..." %}</h2></div>

{% endblock second_column %}

{% block morecrumbs %}
<li><a href="{{ order.get_absolute_url }}">{% trans "Order" %} {{ order.get_footer }}</a> <span class="divider">/</span></li>
<li><a href="">{{ device.description }}</a> <span class="divider">/</span></li>
<li class="active">{% trans "Service Parts" %}</li>
{% endblock morecrumbs %}

servo/templates/orders/search.html
{% load i18n %}

{% if orders %}
    {% include "orders/list.html" %}
{% else %}
    <h1 class="muted text-center">{% trans "No orders found" %}</h1>
{% endif %}